# -*- coding: utf_8 -*-

from direct.showbase.ShowBase import ShowBase
from modules.location import gameLocation
from modules.tank import gameTank
from modules.bot import gameBot
from pandac.PandaModules import *
from direct.gui.DirectGui import *
import sys

###
loadPrcFileData('', 'load-display pandagl')
#loadPrcFileData('', 'load-display pandadx9')
#loadPrcFileData('', 'load-display pandadx8')

loadPrcFileData('', 'window-title Tanki')
loadPrcFileData('', 'fullscreen 0')
loadPrcFileData('', 'sync-video 0')
loadPrcFileData('', 'text-encoding utf8')
#loadPrcFileData('', 'red-blue-stereo 1')
#loadPrcFileData('', 'win-size 1440 900')
#loadPrcFileData('', 'win-size 1024 600')
#loadPrcFileData('', 'window-inverted 1')


#loadPrcFileData('', 'framebuffer-multisample 1')
#loadPrcFileData('', 'multisamples 2')

class MyApp(ShowBase):
	def __init__(self):
		ShowBase.__init__(self)
		
		base.accept("escape", sys.exit)
		
		#render.setAntialias(AntialiasAttrib.MAuto)
		#render.setAntialias(AntialiasAttrib.MNone)
		#render.setAntialias(AntialiasAttrib.MPoint)
		#render.setAntialias(AntialiasAttrib.MLine)
		#render.setAntialias(AntialiasAttrib.MPolygon)
		#render.setAntialias(AntialiasAttrib.MMultisample)
		
		
		# текстовка хелпа
		#########################################################
		self.font = loader.loadFont('arial.ttf')
		self.title = self.addTitle(u"BETA ТАНЧИКИ :)")
		self.inst1 = self.addInstructions(0.95, u"[ESC]: Выход")
		self.inst2 = self.addInstructions(0.90, u"[Left Arrow]: Поворот танка в лево")
		self.inst3 = self.addInstructions(0.85, u"[Right Arrow]: Поворот танка в право")
		self.inst4 = self.addInstructions(0.80, u"[Up Arrow]: Вперед")
		self.inst5 = self.addInstructions(0.75, u"[Down Arrow]: Назад")
		self.inst6 = self.addInstructions(0.70, u"[A]: Поворот башни влево")
		self.inst7 = self.addInstructions(0.65, u"[S]: Поворот башни вправо")
		self.inst8 = self.addInstructions(0.60, u"[A]: Поворот камеры влево")
		self.inst9 = self.addInstructions(0.55, u"[S]: Поворот камеры вправо")
		self.inst10 = self.addInstructions(0.50, u"[PgUp]: Поднять камеру")
		self.inst11 = self.addInstructions(0.45, u"[PgDown]: Опустить камеру")
		self.inst12 = self.addInstructions(0.40, u"[Space]: Выстрел")
		#############################################################

		"""
		environ = gameLocation()
		environ.loadMap("res/geometry/mapa22")
		player = gameTank("res/actors/tank", (0,0,1,0,0,0),"Т-34\nСупер танк",1)
		"""
		
		#"""
		environ=gameLocation()
		environ.initTerrain()
		environ.loadTerrain('res/textures/heightfield.png')
		#environ.setTexture('res/textures/grass1.png',20,20)
		environ.setTexture('res/textures/grass2.png',1,1)
		environ.setLights(Vec4(0.6,0.6,0.6,1), Vec4(1,1,1,1))
		player = gameTank("res/actors/tank", (0,0,80,0,0,0),"Т-34\nСупер танк",5)
		#"""
		
		self.bots=[]
		
		
		for k in xrange(-2,2):
			for h in xrange(-3,1):
				self.bots.append(gameBot("res/actors/tank", (k+5,h+5,150,0,0,0),"Т-34\nСупер БОТ 1",5))
		
		
		#bot1 = gameBot("res/actors/tank", (1,0,0.932,0,0,0),"Т-34\nСупер БОТ 1",1)
		#bot2 = gameBot("res/actors/tank", (-2,7.5,0.932,15,0,0),"Т-34\nСупер БОТ 2",1)
		#bot3 = gameBot("res/actors/tank", (2,-7.5,0.932,75,0,0),"Т-34\nСупер БОТ 3",1)
		#bot4 = gameBot("res/actors/tank", (-1,-3,0.932,45,0,0),"Т-34\nСупер БОТ 4",1)
		
	# вывод инструкции
	def addInstructions(self, pos, msg):
		return OnscreenText(text=msg, style=1, fg=(1,1,1,1), font = self.font, pos=(-1.3, pos), align=TextNode.ALeft, scale = .04, shadow=(0,0,0,1))

	# вывод текста
	def addTitle(self, text):
		return OnscreenText(text=text, style=1, fg=(1,1,1,1), font = self.font, pos=(1.3,-0.95), align=TextNode.ARight, scale = .04, shadow=(0,0,100,1))


app = MyApp()
#render.explore()
run()