# -*- coding: utf_8 -*-

from pandac.PandaModules import *

class gameLocation():
	#def __init__(self, model):
	
	def loadMap(self, model):
		#карта
		self.loc = loader.loadModel(model)
		self.loc.reparentTo(render)
		self.loc.setScale(0.0025, 0.0025, 0.0025)
		self.loc.setPos(0,0,0)
		#устанавливаем маску для коллизии
		#self.loc.setCollideMask(BitMask32(1))
		
		# общее освещение
		self.ambientLight = render.attachNewNode( AmbientLight( "ambientLight" ) )
		self.ambientLight.node().setColor( Vec4(0.6,0.6,0.6,1) )
		
		# точечный источник
		self.PointLight = camera.attachNewNode( PointLight( "PointLight" ) )
		self.PointLight.node().setColor( Vec4(1,1,1,1) )
		self.PointLight.node().setAttenuation( Vec3(.1,0.04,0.0) ) 
		
		# Говорим, что нужно освещать рендер
		render.setLight( self.ambientLight )
		render.setLight( self.PointLight )
		
	def initTerrain(self):
			self.terrain=GeoMipTerrain("Terrain")
			taskMgr.add(self.update,'location_update')

	def loadTerrain(self,hfFile):
			self.terrain.setHeightfield(Filename(hfFile))
			self.terrain.setBlockSize(32)
			self.terrain.setFactor(64)
			self.terrain.setMinLevel(2)
			self.terrain.getRoot().reparentTo(render)
			self.terrain.getRoot().setSz (20)
			self.terrain.generate()
			root = self.terrain.getRoot()
			#root.setScale(1,1,1)
			root.setPos(-70,-70,0)
			
			
			
			
			
			
			gnodes = root.findAllMatches("+GeomNode")
			
			
			for gnode in gnodes:
				gnode.node().setIntoCollideMask(BitMask32.bit(5))
			
	def setTexture(self,texFile,sx,sy):
			self.terrain.getRoot().setTexture(loader.loadTexture(texFile))
			self.terrain.getRoot().setTexScale(TextureStage.getDefault(), sx, sy)
			self.terrain.getRoot().getTexture().setMinfilter(Texture.FTLinearMipmapLinear)
			
	def setLights(self,ambient_l,camera_l):
			self.ambientLight = render.attachNewNode( AmbientLight( "ambientLight" ))
			self.pointLight = camera.attachNewNode( PointLight( "PointLight" ) )
			self.ambientLight.node().setColor(ambient_l)
			self.pointLight.node().setColor(camera_l)
			render.setLight( self.ambientLight )
			render.setLight( self.pointLight )

	def update(self,task):
			self.terrain.update()
			#self.terrain.getRoot().setRenderModeWireframe()
			return task.cont 

